/** Created by Ed Hong, 9/30/04.
  *  contains starter code to load a 2D matrix from a file.
  *  Use for homework 1 programming:
  *
  * Problem:
  *   Write a method that does the following:
  *    Given a 2D array of integers as input, find the two adjacent integers
  *   in the array that give the highest total sum out of all possible
  *   adjacent integers. Integers in the array are adajecent if they are
  *   immediately above, below, left, or right of each other. (Diagonally
  *   adjacent does not count as adjacent in this problem). Your method should
  *   return the total of the two integers that you found.
  *
  *   Your program should read the input array from a file
  *     and printout the final sum. (The file reading is already done for you).
  *
  *  Example solution 1: given the array from test1.txt,  A =
     0   5   8
     20  1  11
     2  10  12
     you should return 23, representing the sum A[1][2] + A[2][2].

  *  Example solution 2: given the array from test2.txt, B =
     2 -1
     3 5
     8 7
     6 4
     7 7
     you should return 15, representing the sum B[2][0] + B[2][1].
  *
  *
  */

import java.util.*;
import java.io.*;


public class Homework1 {

  public static void main(String[] args) throws java.io.FileNotFoundException
  {
	Scanner keyboardscanner = new Scanner(System.in);
	String filename;
	if (args.length==1)
			filename = args[0]; // input file name in command line argument
	else {
			// ask for input file name
		System.out.println("Enter input file name (for example, test1.txt)");
		filename = keyboardscanner.nextLine();
    }
    int input[][] = read2DIntArrayfromFile(filename);
    // call the method(s) that figure out the problem solution
    //   and print out the solution.

  }

// Reads integers from the file whos name is given by parameter filename
// Returns a 2D integer array.
// The first two integers in filename are the number of rows, and number of columns in the
//   2D array. The next integers in filename are then read in order, and placed into a 2D
//  array of integers. The array is filled row by row, left to right.
// Reports an error if not enough integers are in the file.
  public static int[][] read2DIntArrayfromFile(String filename) throws java.io.FileNotFoundException
  {
    Scanner filescanner;
	InputStream	instream;
	System.out.println("Reading file " + filename);

	instream = new FileInputStream(filename);
	filescanner = new Scanner(instream);

	int numRows, numCols; // read the number of rows and columns.
	numRows = filescanner.nextInt();
    numCols = filescanner.nextInt();
    int inputArray[][] = new int[numRows][numCols];
    int i=0;
    int j=0;
    System.out.println(
    		numRows + " x " + numCols + " array.");
	int counter =0;
    // read all the data
    for (i=0; i < numRows; i++) {
		for (j=0; j< numCols; j++) {
			if (filescanner.hasNextInt()) {
                  inputArray[i][j] = filescanner.nextInt();
                  counter++;
			}
			else {
				System.out.println("Error reading input; cannot read integer for location ["+//
							i + "][" + j +"].");
				return null;
			}
		}
    }
    System.out.println("Read "+ (counter) + " ints into " +
    		numRows + " x " + numCols + " array.");

    		// debugging statements.
  /*  for (i=0; i < numRows; i++) {
		for (j=0; j< numCols; j++)
			System.out.print(inputArray[i][j] + " ");
		System.out.println("");
	} */
    return inputArray;
  }

}